// class code demo for Class Notes 19
// Shows use of the functions red, blue, green, get, and hex and unhex
// along with the use of loadPixels and the pixels array
void setup( )
{
  size( 450, 400 );
  textSize(14);
  
  color c = color( 50, 150, 250 );
  fill( c );
  rect(0, 0, 50, 50 );
  
  fill( 255, 0, 0 );
  rect( 100, 0, 50, 50 );
  
  fill( 0, 255, 0 );
  rect( 200, 0, 50, 50 );
  
  fill( 0, 0, 255);
  rect( 300, 0, 50, 50 );
  
  fill( 0 );
  text( "Printing the value of the color c:   " + c, 10, 70 );
  text( "Printing the value of c as a HEX value:  " + hex( c ), 10, 90 );
  text( "Printing decimal equivalent of the Hex value FF:   " + unhex("FF"), 10, 110 );
  text( "Printing decimal equivalent of the Hex value 32:   " + unhex("32"), 10, 130 );
  text( "Printing decimal equivalent of the Hex value 96:   " + unhex("96"), 10, 150 );
  text( "Printing decimal equivalent of the Hex value FA:   " + unhex("FA"), 10, 170 );
  
  // get gets the color of the pixels that is at coordinates 10, 10
  color c1 = get( 10, 10);
  // the red(), green(), and blue() functions get the actual color values for red, green and blue in the
  // color variable c1
  text( "Red value of pixel( 10, 10 ) is " + red( c1 ), 10, 190 );
  text( "Green value of pixel( 10, 10 ) is " + green( c1 ), 10, 210 );
  text( "Blue value of pixel( 10, 10 ) is " + blue( c1 ), 10, 230 );
  
  text( "Click the mouse at different places on the screen.", 10, 255 );
}

void draw( ){}

void mousePressed( )
{
  fill( 204 );
  noStroke ( );
  rect( 0, 255, width, height );
  fill( 0 );
  // loadPixels( ) gets a copy of the array data that is used to display the stuff in the graphics window
  // and stores it in an array named pixels.
  loadPixels( );
  // See page 5 of the class notes Set19  to see how the next line of code works.
  int index = mouseY*width + mouseX;
  text( "Color value at mouse " + mouseX + ", " + mouseY + " which is at pixels[" + index + "]",
        10, 280 );
  text( "Red value is " + red( pixels[index]), 10, 300);
  text( "Green value is " + green( pixels[index]), 10, 320);
  text( "Blue value is " + blue( pixels[index]), 10, 340);
}
